*8290.6 GST 230  Comparison routine
*
*  This module forms part of the example program.  It is used by the SORT
*routine to compare records.  As used by the example program, the records
*are file names.
*
*  The collating sequence is, control codes and punctuation first (in
*ASCII order), then numbers, then letters (upper and lower case being
*equivalent).
*
*  Each record is a sequence of ASCII codes termiated by a newline.
*
         INCLUDE  MDV2_MACRO_LIB

*Interface definition:
*
*        Registers     On entry             On exit
*
*        D0.L          don't care           result of comparison
*        A0.L          pointer to a record  preserved
*        A1.L          pointer to a record  preserved
*        others        don't care           preserved
*
* ... where "result of comparison" is defined as follows ...
*
*  D0 < 0 means record pointed to by A0 collates EARLIER than (A1)
*  D0 = 0 means A0 & A1 point to identical records
*  D0 > 0 means record pointed to by A0 collates later.

CH.EOL   EQU      $0A               Newline code

         SECTION CODE

         XDEF     COMPARE

         SUBROUTINE$ COMPARE,D1/A0-A1
*
*           repeat check of characters until one of the characters
*           is an end of line character
*
            WHILE    (A0) NE.B #CH.EOL AND (A1) NE.B #CH.EOL DO.L
               CMP.B    (A0)+,(A1)+

               IF       NE THEN.L
                  MOVE.B   -1(A0),D0          The two bytes ...
                  MOVE.B   -1(A1),D1          ... which don't match

                  IF D0 GE.B #'a' AND D0 LE.B #'z' THEN   lower case

                     IF       D1 GE.B #'a' AND D1 LE.B #'z' THEN
                        SUB.B    D1,D0
                     ELSEIF   D1 GE.B #'A' AND D1 LE.B #'Z' THEN
                        SUB.B    #('a'-'A'),D0
                        SUB.B    D1,D0
                     ELSE                       D1 not alphabetic
                        MOVEQ    #1,D0             so A1 sorts earlier
                     ENDIF

                  ELSEIF.L D0 GE.B #'A' AND D0 LE.B #'Z' THEN   upper case

                     IF       D1 GE.B #'a' AND D1 LE.B #'z' THEN
                        ADD.B    #('a'-'A'),D0
                        SUB.B    D1,D0
                     ELSEIF   D1 GE.B #'A' AND D1 LE.B #'Z' THEN
                        SUB.B    D1,D0
                     ELSE                       D1 not alphabetic
                        MOVEQ    #1,D0             so A1 collates earlier
                     ENDIF

                  ELSEIF   D0 GE.B #'0' AND D0 LE.B #'9' THEN   numeric

                     IF       D1 GE.B #'0' AND D1 LE.B #'9' THEN   both numeric
                        SUB.B    D1,D0
                     ELSEIF   D1 GE.B #'a' AND D1 LE.B #'z' THEN   alphabetic
                        MOVEQ    #-1,D0            so A0 collates earlier
                     ELSEIF   D1 GE.B #'A' AND D1 LE.B #'Z' THEN
                        MOVEQ    #-1,D0            likewise
                     ELSE     D0 numeric and D1 control or punctuation
                        MOVEQ    #1,D0             so A1 collates earlier
                     ENDIF

                  ELSE       D0 is not alphanumeric

                     IF       D1 GE.B #'a' AND D1 LE.B #'z' THEN
                        MOVEQ    #-1,D0
                     ELSEIF   D1 GE.B #'A' AND D1 LE.B #'Z' THEN
                        MOVEQ    #-1,D0
                     ELSEIF   D1 GE.B #'0' AND D1 LE.B #'9' THEN
                        MOVEQ    #-1,D0
                     ELSE
                        SUB.B    D1,D0
                     ENDIF

                  ENDIF

                  EXT.W    D0
                  EXT.L    D0

                  IF D0 NE.L #0 THEN   ; not letters in different cases
                    BRA.S    EXIT           ; comparison complete
                  ENDIF
               ENDIF

            ENDWHILE
*
*              One of the strings has reached end of line
*
            IF     (A0) EQ.B #CH.EOL THEN

               IF  (A1)  EQ.B #CH.EOL THEN
                  CLR.L D0                records identical

               ELSE
                  MOVEQ    #-1,D0      1st record shorter, so earlier
               ENDIF
            ELSE
               MOVEQ    #1,D0          2nd record shorter
            ENDIF
*
*     Exit label to allow a jump out of the comparison loop after
*     a difference has been found
*
EXIT
         END$     COMPARE

         END

